#include <avr/io.h>
#include <util/delay.h>
#include <inttypes.h>
#include "apa102.h"

//#############################################################################################

void APA102Init(void)
{
		//Porty sterujce (CLK, DATA) jako wyjciowe ze stanami spoczynkowymi = 0
		APA102_AS_OUTPUTS;
}

//#############################################################################################

void APA102SendByte(uint8_t Byte)
{
		for(uint8_t i=0; i<8; ++i)
		{
				if(Byte & 0x80) APA102_DATA_1; else APA102_DATA_0;
				APA102_CLK_1;
				Byte <<= 1;
				APA102_CLK_0;
		}
}

//#############################################################################################

void APA102StartTrans(void)
{
		//Start Frame
		APA102SendByte(0x00);
		APA102SendByte(0x00);
		APA102SendByte(0x00);
		APA102SendByte(0x00);
}

//#############################################################################################

void APA102StopTrans(uint16_t numberOfLeds)
{
		//End Frame
		for (uint16_t i = 0; i < (14+numberOfLeds)/16; ++i) APA102SendByte(0xFF);
}

//#############################################################################################

void APA102SendRGBdata(uint8_t Brightness, uint8_t R, uint8_t G, uint8_t B)
{
		//Brightness
		APA102SendByte(0b11100000|Brightness );
		APA102SendByte(B);
		APA102SendByte(G);
		APA102SendByte(R);
}

//#############################################################################################
